; Fibonacci benchmark

(##declare (standard-bindings) (fixnum)) ; Compiler: generate fast code

(define (fibonacci n)

  (define (fib n) (if (< n 2) n (+ (fib (- n 1)) (fib (- n 2)))))

  (fib n))

; In C, this is:
;
; int fib(n) int n; { if (n<2) return n; else return fib(n-1)+fib(n-2); }

; Timings on 2.5 meg Mac+ for (fibonacci 20):
;
;                       secs   relative speed
; Interpreted code:    26.75      52.45
; Compiled code:        0.51       1.00
; Think C 4.0:          0.60       1.18
;
; note: Think C has 16 bit ints, Gambit has 29 bit fixnums
